/*	MPEG layer 3 tables include file
 *	Copyright (c) 1999 Albert L Faber
 */

#pragma once

#if 0
struct type1_t{
  unsigned char no;
  unsigned char width;
  unsigned char minval_2;
  float   quiet_thr;
  float   norm;
  float   bark;
};

struct type2_t{
  unsigned char no;
  unsigned char width;
  float   quiet_thr;
  float   norm;
  float   SNR;
  float   bark;
};

struct type34_t{
  unsigned no:5;
  unsigned cbw:3;
  unsigned bu:6;
  unsigned bo:6;
  unsigned w1_576:10;
  unsigned w2_576:10;
};

struct type5_t{
  size_t  len1;
  const type1_t *const tab1;
  size_t  len2;
  const type2_t *const tab2;
  size_t  len3;
  const type34_t *const tab3;
  size_t  len4;
  const type34_t *const tab4;
};

extern const type5_t table5[6];

#endif

#define HTN	34

struct huffcodetab {
  unsigned int xlen;          /* max. x-index+   */
  unsigned int linmax;        /* max number to be stored in linbits */
  const uint16_t *table;      /* pointer to array[xlen][ylen]  */
  const uint8_t *hlen;        /* pointer to array[xlen][ylen]  */
};

extern const huffcodetab ht[HTN];
    /* global memory block   */
    /* array of all huffcodtable headers */
    /* 0..31 Huffman code table 0..31  */
    /* 32,33 count1-tables   */

extern const uint8_t t32l[];
extern const uint8_t t33l[];

extern const uint32_t largetbl[16 * 16];
extern const uint32_t table23[3 * 3];
extern const uint32_t table56[4 * 4];

extern const int scfsi_band[5];

extern const int bitrate_table    [3][16];
extern const int samplerate_table [3][ 4];
